<?php

namespace Drupal\h5p_challenge\FetchClass;

use Drupal\h5p\Entity\H5PContent;

/**
 * Class H5PChallenge
 */
class H5PChallenge {

  /**
   * Returns content title by content identifier. Title of H5PContent entity is
   * used, not the title of the container Node or Entity.
   * @param  int    $id
   *   Content identifier
   * @return string
   *   Content title or empty string
   */
  public static function getContentTitleById(int $id) {
    $content = H5PContent::load($id);

    if ($content) {
      return $content->get('title')->value;
    }

    return '';
  }

  /**
   * Determines if current challenge is still active.
   * @return boolean
   *   Active or not
   */
  public function isActive() {
    return (int)$this->finished > time();
  }

  /**
   * Returns content title used for current challenge.Title of H5PContent
   * entity is used, not the title of the container Node or Entity.
   * @return string
   *   Content title or empry string
   */
  public function getContentTitle() {
    return $this->getContentTitleById($this->content_id);
  }

}
